=== share/hedgewars/Data/Sounds/voices/CMakeLists.txt ===
foreach(dir
    British
    Classic
    Default
    Mobster
    Pirate
    Robot
    Russian
    Singer
    Surfer
    Default_uk
    Default_es
    HillBilly
    )
    add_subdirectory(${dir})
endforeach(dir)
