=== debian/changelog ===
hedgewars (0.9.19.3-1~ubuntu13.04.1) raring-backports; urgency=low

  * No-change backport to raring (LP: #1191816)

 -- Felix Geyer <debfx@ubuntu.com>  Fri, 21 Jun 2013 17:55:04 +0200

hedgewars (0.9.19.3-1) unstable; urgency=low

  * New upstream tarball.
    - Addressed some more bugs and linking failures.
    - Dropped fix-physfs.patch accepted upstream.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Tue, 11 Jun 2013 10:53:33 +0200

hedgewars (0.9.19.2-2) unstable; urgency=low

  * debian/control
    - Changed package description
    - added fix-physfs.patch
      this basically reverts the problem with i386 machines
      see upstream issue 665.
      Revert upstream commit 3883b5dc600c

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 10 Jun 2013 18:21:36 +0200
